//
//  EAGLView.h
//  VirtuAR
//
//  Created by Romain on 04/02/10.
//  Copyright __MyCompanyName__ 2010. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <QuartzCore/QuartzCore.h>
#import <CoreLocation/CoreLocation.h>

#import "ESRenderer.h"

// This class wraps the CAEAGLLayer from CoreAnimation into a convenient UIView subclass.
// The view content is basically an EAGL surface you render your OpenGL scene into.
// Note that setting the view non-opaque will only work if the EAGL surface has an alpha channel.
@interface EAGLView : UIView
{    
	id <ESRenderer> renderer;
	
@private
	BOOL animating;
	BOOL displayLinkSupported;
	NSInteger animationFrameInterval;
	// Use of the CADisplayLink class is the preferred method for controlling your animation timing.
	// CADisplayLink will link to the main display and fire every vsync when added to a given run-loop.
	// The NSTimer class is used only as fallback when running on a pre 3.1 device where CADisplayLink
	// isn't available.
	id displayLink;
    NSTimer *animationTimer;
	UIAccelerationValue accel[3];
	CLLocationDirection heading;
	BOOL firstFrame;
	uint _nbFrames;
	NSTimeInterval _lastFPSReport;
	NSTimeInterval _lastFrameTimeStamp;
	NSTimeInterval _lastFrameLength;
}

@property (readonly, nonatomic, getter=isAnimating) BOOL animating;
@property (nonatomic) NSInteger animationFrameInterval;
@property (nonatomic, retain) id <ESRenderer> renderer;

- (void) startAnimation;
- (void) stopAnimation;
- (void) drawView:(CADisplayLink *)sender;
-(void)setupView;
@end
