//
//  FIFOStack.h
//  videoGL
//
//  Created by Romain Criton on 18/08/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>


@interface FIFOStack: NSObject
{
	// Properties
	uint _maxCapacity;
	uint _lowThreshold;
	NSCondition *_lowBufferTrigger;
	
	NSMutableArray *_array;
}

-(id)initWithCapacity:(NSUInteger)numItems;
-(id)dequeue;
-(void)enqueue:(id) obj;
-(id)dequeueSync;
-(void)enqueueSync:(id) obj;
-(void)enqueueWaitIfFull:(id) obj;
-(void)enqueueThenWaitIfFull:(id) obj;
-(id)dequeueSignalIfLow;
-(void)push:(id)obj;
-(void)pushSync:(id)obj;

@property (nonatomic) uint maxCapacity;
@property (nonatomic) uint lowThreshold;
@property (nonatomic, retain) NSCondition *lowBufferTrigger;
@property (nonatomic, readonly) uint count;

@end
