//
//  MWLinkedList.h
//  VirtuAR
//
//  Created by Romain on 11/02/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "MWLink.h"

typedef enum
{
	MWLL_SORTED_ASCENDING = 1,
	MWLL_UNSORTED = 0,
	MWLL_SORTED_DESCENDING = -1
} MWLLSortType;

@protocol MWLinkedListCompare
-(int)compareToObject:(id)obj;
@end

@interface MWLinkedList : NSObject
{
	MWLink *head;
	MWLink *tail;
	MWLink *cursor;
	uint count;
	MWLLSortType sortType;
}
-(void)addLink:(MWLink *)link;
-(void)addAtHeadLink:(MWLink *)link;
-(void)addAtTailLink:(MWLink *)link;
-(void)insertLink:(MWLink *)link atIndex:(uint)index;
-(void)insertLink:(MWLink *)newLink beforeLink:(MWLink *)before;
-(void)insertLink:(MWLink *)newLink afterLink:(MWLink *)after;
-(MWLink *)getLinkAtIndex:(uint)index;
-(MWLink *)getLinkForObject:(id)obj;
-(void)addObject:(id)obj;
-(void)addAtHeadObject:(id)obj;
-(void)addAtTailObject:(id)obj;
-(void)insertObject:(id)obj atIndex:(uint)index;
-(void)insertObject:(id)obj beforeObject:(id)before;
-(void)insertObject:(id)obj afterObject:(id)after;
-(void)insertObject:(id)obj beforeLink:(MWLink *)before;
-(void)insertObject:(id)obj afterLink:(MWLink *)after;
-(id)getObjectAtIndex:(uint)index;

-(id)removeHead;
-(id)removeTail;
-(id)removeAtIndex:(uint)index;
-(void)removeLink:(MWLink *)link;
-(void)removeObject:(id)obj;
-(void)push:(id)obj;
-(id)pop;

-(void)replaceObject:(id)oldObj withObject:(id)newObj;
-(void)replaceLink:(MWLink *)oldLink   withLink:(MWLink *)newLink;
-(void)replaceAtIndex:(uint)index withObject:(id)newObj;
-(void)replaceAtIndex:(uint)index withLink:(MWLink *)newlink;

-(void)rewindCursor;
-(void)setCursorToTail;
-(MWLink *)nextLink;
-(MWLink *)prevLink;
-(id)nextObject;
-(id)prevObject;

-(void)sort;
-(void)insertSortedLink:(MWLink *)link;
-(void)insertSortedObject:(id)obj;

-(void)pruneLinks;

@property (nonatomic, retain) MWLink *head;
@property (nonatomic, retain) MWLink *tail;
@property (nonatomic, assign) MWLink *cursor;
@property (nonatomic) uint count;
@property (nonatomic) MWLLSortType sortType;

@end
