//
//  MWMediaPlayer.h
//  videoGL
//
//  Created by Romain Criton on 28/07/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "MWMediaFile.h"
#import "MWAudioDecoder.h"
#import "MWVideoDecoder.h"
#import "FIFOStack.h"
#import <QuartzCore/QuartzCore.h>

@class MWMediaPlayer;
@protocol MWMediaPlayerDelegate <NSObject>
-(void)blitFrame:(MWVideoFrame *)frame fromMediaPlayer:(MWMediaPlayer *)player;
@end


@interface MWMediaPlayer : NSObject
{
	// Properties
	MWMediaFile *_file;
	id<MWMediaPlayerDelegate> _delegate;
	
	NSThread *_readThread;
	NSThread *_videoDecodeThread;
	FIFOStack *_videoFrameBuffer;
	FIFOStack *_audioFrameBuffer;
	FIFOStack *_videoPacketBuffer;
	NSCondition *_lowBufferTrigger;
	MWAudioDecoder *_audioDecoder;
	MWVideoDecoder *_videoDecoder;
	CADisplayLink *_displayLink;
	NSRunLoop *_displayLinkLoop;
	uint _blitCount;
	BOOL _useAudio;
	BOOL _useVideo;
}

-(id)initWithFile:(MWMediaFile *)file;
-(void)play;
-(void)pause;
-(void)stop;

@property (nonatomic, retain) MWMediaFile *file;
@property (nonatomic, readonly) FIFOStack *videoFrameBuffer;
@property (nonatomic, assign) id<MWMediaPlayerDelegate> delegate;
@end
