//
//  MWVideoDecoder.h
//  videoGL
//
//  Created by Romain Criton on 28/07/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "MWMediaFile.h"
#include "libswscale/swscale.h"
#import "MWVideoFrame.h"

typedef struct
{
	uint			nbFrames;
	NSTimeInterval	minDuration;
	NSTimeInterval	maxDuration;
	NSTimeInterval	avgDuration;
	NSTimeInterval	sigmaSquaredDuration;
	
	NSTimeInterval	totalDuration;
	NSTimeInterval	totalSquareSumDuration;
	NSTimeInterval	currentFrameDuration;
	
	NSTimeInterval	minPeriod;
	NSTimeInterval	maxPeriod;
	NSTimeInterval	avgPeriod;
	NSTimeInterval	sigmaSquaredPeriod;
	
	NSTimeInterval	totalPeriod;
	NSTimeInterval	totalSquareSumPeriod;
	NSTimeInterval	prevFrameStart;
	NSTimeInterval	instantFrameRateWindowLength;
	NSTimeInterval	instantFrameRateWindowStart;
	uint			instantFrameCount;
	float			instantFrameRate;
	BOOL			frameStart;
} MWVideoDecoderStats;

@interface MWVideoDecoder : NSObject
{
	// Properties
	MWMFVideoSettings _videoSettings;
	MWVideoDecoderStats _stats;
	
	struct SwsContext *_scalerCtx;
	AVCodecContext *_codecCtx;
	AVCodec *_codec;
	AVFrame *_frame;
}

-(NSTimeInterval)pts2Timestamp:(int64_t)pts;

-(id)initWithCodec:(MWMediaCodec *)codec;
-(MWVideoFrame *)decodePacket:(MWMediaPacket *)packet;
-(NSTimeInterval)getTimeStampForPacket:(MWMediaPacket *)packet;

@property (nonatomic, readonly) MWMFVideoSettings videoSettings;
@property (nonatomic, readonly) MWVideoDecoderStats stats;

@end
