//
//  VAR3DSprite.h
//  VirtuAR
//
//  Created by Romain on 05/02/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "VARObject.h"
#import "VARTexture.h"

@interface VAR3DSprite : VARObject
{
	GLfloat width;
	GLfloat height;
	GLfloat vertices[4][3];
	GLfloat normals[4][3];
	GLfloat uvmap[4][2];
	GLfloat textureScaleX;
	GLfloat textureScaleY;
	GLint textureWrapS;
	GLint textureWrapT;
	BOOL billboard;
	GLfloat billboardMatrix[4][4];
	GLfloat scalingMatrix[4][4];
	GLfloat scalingFactor;
	VARTexture *texture;
}

-(void)setTextureScale:(GLfloat)scale;
-(void)setSizeWidth:(GLfloat)w Height:(GLfloat)h;
-(void)setSize:(GLfloat)size;
-(void)setTextureFileName:(NSString *)filename;
-(void)setTextureView:(UIView *)v;

@property (nonatomic) GLfloat width;
@property (nonatomic) GLfloat height;
@property (nonatomic) GLfloat textureScaleX;
@property (nonatomic) GLfloat textureScaleY;
@property (nonatomic) GLint textureWrapS;
@property (nonatomic) GLint textureWrapT;
@property (nonatomic) BOOL billboard;
@property (nonatomic, retain) VARTexture *texture;

@end
