//
//  VARBitmapTexture.m
//  VirtuAR
//
//  Created by Romain on 01/03/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "VARBitmapTexture.h"

static NSMutableDictionary *resourcesTextureNames = nil;

@implementation VARBitmapTexture

-(id)initWithPNGImageFromResources:(NSString *)filename;
{
	if(self = [super init])
	{
		if(resourcesTextureNames == nil)
		{
			resourcesTextureNames = [[NSMutableDictionary alloc] init];
		}
		else
		{
			[resourcesTextureNames retain];
		}
		
		[self setPNGImageFromResources:filename];
	}
	return self;
}

-(void)setPNGImageFromResources:(NSString *)filename
{
	NSNumber *texName = [resourcesTextureNames valueForKey:filename];
	if(texName != nil)
	{
		// Texture already loaded
		name[0] = [texName intValue];
		return;
	}
	
	NSString *path = [[NSBundle mainBundle] pathForResource:filename ofType:@"png"];
    NSData *texData = [[NSData alloc] initWithContentsOfFile:path];
    UIImage *image = [[UIImage alloc] initWithData:texData];
	[texData release];

	[self setDataFromUIImage:image];
	[image release];

	[resourcesTextureNames setValue:[NSNumber numberWithInt:name[0]]  forKey:filename];

}	

-(void)dealloc
{
	[resourcesTextureNames release];
	[super dealloc];
}
@end
