//
//  VARCamera.h
//  VirtuAR
//
//  Created by Romain on 05/02/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "VARObject.h"
#import "VAR3DSprite.h"
#import <CoreLocation/CoreLocation.h>

@interface VARCamera : VARObject
{
	@public
	CGPoint viewSize;
	GLfloat fieldOfView;
	GLfloat zNear;
	GLfloat zFar;
	Vector3D accel;
	CLLocationDirection direction;
	GLfloat positionChecksum;
	
	@private
	GLfloat frustumLeft;
	GLfloat frustumRight;
	GLfloat frustumBottom;
	GLfloat frustumTop;
	Vector3D _referencePoint;
	GLfloat _azimuth;
	GLfloat _elevation;
	GLfloat _dazimuth;
	GLfloat _delevation;

}

-(id)init:(CGPoint)size;
-(id)initWithSizeX:(float)x Y:(float)y;
-(void)setViewSizeWithX:(float)x Y:(float)y;
-(void)setAccelX:(GLfloat)x Y:(GLfloat)y Z:(GLfloat)z;
-(void)setAccelFromPointer:(Vector3D *)acc;
-(void)setReferencePoint:(CGPoint)point;
-(void)moveReferencePointTo:(CGPoint)point;
-(void)resetAzimuthAndElevation;

@property (nonatomic) CGPoint viewSize;
@property (nonatomic) GLfloat fieldOfView;
@property (nonatomic) GLfloat zNear;
@property (nonatomic) GLfloat zFar;
@property (nonatomic) Vector3D accel;
@property (nonatomic) CLLocationDirection direction;
@property (nonatomic) GLfloat positionChecksum;

@end
