//
//  VARObject.h
//  VirtuAR
//
//  Created by Romain on 04/02/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <OpenGLES/ES1/gl.h>
#import <OpenGLES/ES1/glext.h>
#import <CoreLocation/CoreLocation.h>

#import "VARGLutils.h"
#import "MWLinkedList.h"

@class VARCamera;

@interface VARObject : NSObject <MWLinkedListCompare>
{
	@public
	Vector3D cartesianPos;
	Vector3D vectorUp;
	Vector3D vectorFront;
	GLfloat orientationMatrix[4][4];
	NSTimeInterval lastDraw;
	VARCamera *cam;
	CLLocationDistance distanceToCam;
	
	@private
	BOOL mustUpdateDistanceToCam;
	GLfloat previousPositionChecksum;
}

-(void)draw:(NSTimeInterval) timestamp;
-(void)setCartesianPosWithX:(GLfloat)x Y:(GLfloat)y Z:(GLfloat)z;
-(void)setCartesianPos2DWithX:(GLfloat)x Y:(GLfloat)y;
-(void)setCartesianPos2D:(Vector2D)pos;
-(void)setCartesianPosFromPointer:(Vector3D *)pos;
-(void)setCartesianPos2DFromPointer:(Vector2D *)pos;
-(void)setVectorUpWithX:(GLfloat)x Y:(GLfloat)y Z:(GLfloat)z;
-(void)setVectorUpFromPointer:(Vector3D *)up;
-(void)setVectorFrontWithX:(GLfloat)x Y:(GLfloat)y Z:(GLfloat)z;
-(void)setVectorFrontFromPointer:(Vector3D *)front;
-(void)updateOrientationMatrix;
-(void)updateOrientationMatrixWithUp:(Vector3D)up Front:(Vector3D)front;
-(void)updateOrientationMatrixWithPointersUp:(Vector3D *)up Front:(Vector3D *)front;
-(GLfloat)distanceToObject:(VARObject *)obj;

-(void)_updateDistanceToCam;

@property (nonatomic, retain) VARCamera *cam;
@property (nonatomic) CLLocationDistance distanceToCam;
@property (nonatomic) Vector3D cartesianPos;
@property (nonatomic) Vector3D vectorUp;
@property (nonatomic) Vector3D vectorFront;
@property (nonatomic) CLLocationDistance altitude;

@end
