//
//  VARWorld.h
//  VirtuAR
//
//  Created by Romain on 04/02/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import <OpenGLES/ES1/gl.h>
#import <OpenGLES/ES1/glext.h>
#import "ESRenderer.h"
#import "VARCamera.h"
#import "MWLinkedList.h"

@interface VARWorld : NSObject <ESRenderer>
{
	EAGLContext *context;
	VARCamera *camera;
	MWLinkedList *objectList;
	VAR3DSprite *horizon;
	VAR3DSprite *compass;
	GLfloat _drawDistance;
	uint _maxObjectCount;
	
	// The pixel dimensions of the CAEAGLLayer
	GLint backingWidth;
	GLint backingHeight;
	
	// The OpenGL names for the framebuffer and renderbuffer used to render to this view
	GLuint defaultFramebuffer, colorRenderbuffer;
	GLuint depthRenderbuffer;
	
	Vector3D accel;
	CLLocationDirection direction;
	Vector2D position;
	BOOL positionChanged;
}

- (void) render:(NSTimeInterval)tstamp;
- (BOOL) resizeFromLayer:(CAEAGLLayer *)layer;
-(void)addObject:(VARObject *)obj;
-(void)removeObject:(VARObject *)obj;

-(void)setLocation:(Vector2D *)pos altitude:(CLLocationDistance)alt direction:(CLLocationDirection)dir acceleration:(Vector3D *)acc;

@property (nonatomic, retain) MWLinkedList *objectList;
@property (nonatomic, retain) VARCamera *camera;
@property (nonatomic) GLfloat drawDistance;
@property (nonatomic) uint maxObjectCount;

@end
